/**
 * CreativeRemote.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Mar 02, 2009 (07:08:06 PST) WSDL2Java emitter.
 */

package com.google.api.ads.dfa.axis.v1_17;

public interface CreativeRemote extends java.rmi.Remote {

    /**
     * Returns the creative with the given id. The client is responsible
     * for
     *         casting this CreativeBase object into one of the specific
     * derived
     *         objects like ImageCreative, HTMLCreative etc.
     */
    public com.google.api.ads.dfa.axis.v1_17.CreativeBase getCreative(long creativeId) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * Returns a single page of creatives matching the given criteria.
     * This criteria can't be null and must contain
     *         either the advertiser or the campaign.
     */
    public com.google.api.ads.dfa.axis.v1_17.CreativeRecordSet getCreatives(com.google.api.ads.dfa.axis.v1_17.CreativeSearchCriteria creativeSearchCriteria) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * Saves the given creative.
     *         If the id specified in the creative object is <= 0,
     *         then it will create a new creative.
     *         Otherwise, it will try to update the creative with that id.
     * It will also create an assignment for the new creative if a campaign
     * is specified.
     */
    public com.google.api.ads.dfa.axis.v1_17.CreativeSaveResult saveCreative(com.google.api.ads.dfa.axis.v1_17.CreativeBase creative, long campaignId) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * Deletes the creative with the given id.
     */
    public void deleteCreative(long creativeId) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * Saves the given creative asset.
     *         The result of saving the asset contains the saved filename
     * of the asset
     *         (which can be different from the original filename to make
     * it unique for the advertiser)
     *         and a url which can be used to retrieve the creative asset
     * data over http.
     */
    public com.google.api.ads.dfa.axis.v1_17.CreativeAssetSaveResult saveCreativeAsset(com.google.api.ads.dfa.axis.v1_17.CreativeAsset creativeAsset) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * Returns the assets matching the given criteria. The search
     * criteria must specify the advertiser.
     */
    public com.google.api.ads.dfa.axis.v1_17.CreativeAssetRecordSet getCreativeAssets(com.google.api.ads.dfa.axis.v1_17.CreativeAssetSearchCriteria creativeAssetSearchCriteria) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * Returns types of Creative.
     */
    public com.google.api.ads.dfa.axis.v1_17.CreativeType[] getCreativeTypes() throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * Associates the given creatives to the campaign.<br>
     *           Note that this method does not associate the creatives to
     * the campaign in a single transaction.
     *           So certain creatives may get successfully associated while
     * some may fail.
     *           Please check the result returned by this method to find
     * out which ones
     *           succeeded and which ones failed.
     */
    public com.google.api.ads.dfa.axis.v1_17.CreativeCampaignAssociationResult[] associateCreativesToCampaign(long campaignId, long[] creativeIds) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * Assigns the creatives to placements and creates a unique ad
     * for each such assignment.
     *           If the assignment was successful, then the result contains
     * the ID and name of the newly created ad.
     *           If the assignment was unsuccessful, then the result contains
     * the corresponding error message.
     */
    public com.google.api.ads.dfa.axis.v1_17.CreativePlacementAssignmentResult[] assignCreativesToPlacements(com.google.api.ads.dfa.axis.v1_17.CreativePlacementAssignment[] creativePlacementAssignments) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * <p>Upload a new RichMedia Asset for a RichMedia Creative. The
     * method accepts
     *           RichMediaAssetUploadRequest as a parameter and returns updated
     * RichMediaCreativeBase
     *           object. In case of any error, it throws exception.</p>
     * 
     *           <p>RichMediaAssetUploadRequest object contains the following
     * fields:</p>
     * 
     *           <ul>
     *             <li><em>assetFileName</em>: File name of the RichMedia
     * Asset to be uploaded</li>
     *             <li><em>fileData</em>: byte array of binary data of the
     * RichMedia Asset to be uploaded</li>
     *             <li>
     *               <em>parentAssetId</em>: Id of the parent RichMedia Flash
     * Asset for which the new asset
     *               will be a child
     *             </li>
     *             <li>
     *               <em>creativeId</em>: Id of Rich Media creative object
     * for which RichMedia asset is being
     *               uploaded.
     *             </li>
     *           </ul>
     */
    public com.google.api.ads.dfa.axis.v1_17.RichMediaCreativeBase uploadRichMediaAsset(com.google.api.ads.dfa.axis.v1_17.RichMediaAssetUploadRequest uploadRequest) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * <p>Replaces a RichMedia Asset for a RichMedia Creative. The
     * method accepts
     *           RichMediaAssetUploadRequest and oldAssetFileName as parameters
     * and returns updated
     *           RichMediaCreativeBase object. In case of any error, it throws
     * exception.</p>
     * 
     *           <p>Following is the field summary:</p>
     * 
     * 
     *           Following is the field summary of RichMediaAssetUploadRequest
     * object:
     * 
     *           <ul>
     *             <li>
     *               <em>oldAssetFileName</em>: File name of the old Rich
     * Media Asset to be replaced by new
     *               one
     *             </li>
     *             <li><em>assetFileName</em>: File name of the RichMedia
     * Asset to be uploaded</li>
     *             <li>
     *               <em>fileData</em>: byte array of binary data of the
     * RichMedia Asset to be uploaded
     *             </li>
     *             <li>
     *               <em>parentAssetId</em>: Id of the parent Rich Media
     * Flash Asset for which the new
     *               asset will be a child
     *             </li>
     *             <li>
     *               <em>creativeId</em>: Id of Rich Media creative object
     * for which RichMedia asset is
     *               being uploaded
     *             </li>
     *           </ul>
     */
    public com.google.api.ads.dfa.axis.v1_17.RichMediaCreativeBase replaceRichMediaAsset(java.lang.String oldAssetFileName, com.google.api.ads.dfa.axis.v1_17.RichMediaAssetUploadRequest replaceRequest) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * <p> Deletes the RichMedia Asset from a RichMedia Creative.
     * The method accepts creativeId
     *           and assetFileName as parameters and returns updated RichMediaCreativeBase
     * object. In case
     *           of any error, it throws exception.</p>
     * 
     *           <p>Following is the field summary:</p>
     * 
     *           <ul>
     *             <li><em>assetFileName</em>: File name of the Rich Media
     * asset to be deleted</li>
     *             <li>
     *               <em>creativeId<em>: Id of the Rich Media creative object
     * from which Rich Media asset
     *               is being deleted
     *             </li>
     *           </ul>
     */
    public com.google.api.ads.dfa.axis.v1_17.RichMediaCreativeBase deleteRichMediaAsset(long creativeId, java.lang.String assetFileName) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * <p>Saves the given creative package in the DoubleClick DART
     * system and returns the saved
     *           RichMediaCreativeBase creative object.</p>
     * 
     *           <p>If the upload is successful, then the response contains
     * saved RichMediaCreativeBase
     *           object. If the upload operation fails, then a DartException
     * is thrown.</p>
     * 
     *           <p>Following is a field summary:</p>
     * 
     *           <ul>
     *             <li>
     *               <em>advertiserId</em>: Id of the advertiser under which
     * the creative package is being
     *               uploaded
     *             </li>
     *             <li>
     *               <em>fileData</em>: byte array containing the actual
     * package data
     *             </li>
     *             <li>
     *               <em>uploadAsFlashInFlashCreative</em>: flag to signify
     * whether to upload a
     *               Flash-In-Flash creative or not
     *             </li>
     *           </ul>
     */
    public com.google.api.ads.dfa.axis.v1_17.RichMediaCreativeBase uploadRichMediaCreativePackage(long advertiserId, byte[] fileData, boolean uploadAsFlashInFlashCreative) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * <p>Replaces the given creative package in the DoubleClick DART
     * system for the specified
     *           creative id and returns the saved RichMediaCreativeBase
     * creative object.</p>
     * 
     *           <p>If the replace operation fails, then a DartException
     * is thrown.</p>
     * 
     *           <p>Following is a field summary:</p>
     * 
     *           <ul>
     *             <li>
     *               <em>creativeId</em>: Id of the creative for which the
     * creative package is to be replaced<
     *             /li>
     *             <li>
     *               <em>fileData</em>: byte array containing the actual
     * package data
     *             </li>
     *           </ul>
     */
    public com.google.api.ads.dfa.axis.v1_17.RichMediaCreativeBase replaceRichMediaCreativePackage(long creativeId, byte[] fileData) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * <p>Gets the external preview URL for the specified saved creative
     * id.</p>
     * 
     *           <p>External preview is only available for valid Rich Media
     * creative types.</p>
     * 
     *           <p>If the creative id specified is not valid Rich Media
     * creative type then DartException
     *           is thrown.</p>
     * 
     *           <p>The default external preview is not available for Flash-in-Flash
     * creatives. If the
     *           creative ID specified is of Flash in Flash creative type
     * then a DartException is thrown.
     *           </p>
     * 
     *           <p>Following is a field summary:</p>
     * 
     *           <ul>
     *             <li>
     *               <em>creativeId</em>: Id of the saved creative for which
     * the external preview URL is required.
     *             </li>
     *           </ul>
     */
    public java.lang.String getRichMediaPreviewURL(long creativeId) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * <p>Creates copy of given list of creatives and returns list
     * of instances of
     *           CreativeCopyResult that contains id and name of newly copied
     * creative or error message if
     *           there was an error creating a copy.
     */
    public com.google.api.ads.dfa.axis.v1_17.CreativeCopyResult[] copyCreative(com.google.api.ads.dfa.axis.v1_17.CreativeCopyRequest[] copyRequests) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * Create creatives from file(s) uploaded in a Creative upload
     * session.
     * 
     *           <p>By calling this service you are saving the creatives
     * that you uploaded to your session
     *           to the DFA system. Use generateCreativeUploadSession operation
     * to get a session and
     *           uploadCreativeFiles to upload your files. Use getCompleteCreativeUploadSession
     * to check
     *           your progress as you go.</p>
     * 
     *           <p>CreativeSaveRequest(s) in CreativeUploadSession objects
     * contains files uploaded in this
     *           session from which creatives will be created. The ID of
     * the new creative or any error
     *           message is set in the same request object.</p>
     */
    public com.google.api.ads.dfa.axis.v1_17.CreativeUploadSession createCreativesFromCreativeUploadSession(com.google.api.ads.dfa.axis.v1_17.CreativeUploadSession creativeUploadSession) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * Generate a new creative upload session given the advertiser
     * ID (advertiser-level)
     *           or campaign ID (campaign-level). Set the campaign ID to
     * 0 if you are looking to work with
     *           the advertiser level creatives.
     * 
     *           <p>Any value above 0 will be assumed to be a valid ID. If
     * there is no valid advertiser or
     *           campaign with the requested positive ID an ApiException
     * will be thrown.</p>
     * 
     *           <p>Once a creative upload session has been generated files
     * can be uploaded to a temporary
     *           space that is associated with this session using the uploadCreativeFiles
     * operation. The
     *           Creatives will not be saved until createCreativesFromCreativeUploadSession
     * has been
     *           called.
     */
    public com.google.api.ads.dfa.axis.v1_17.CreativeUploadSession generateCreativeUploadSession(com.google.api.ads.dfa.axis.v1_17.CreativeUploadSessionRequest creativeUploadSessionRequest) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * Return complete creative upload session information which includes
     * metadata about all
     *           files that were uploaded in the given session.
     * 
     *           <p>You might call this operatoin for example after an upload
     * session has been generated and some
     *           files have been uploaded and you want to check what has
     * been done so far.</p>
     */
    public com.google.api.ads.dfa.axis.v1_17.CreativeUploadSession getCompleteCreativeUploadSession(com.google.api.ads.dfa.axis.v1_17.CreativeUploadSessionSummary creativeUploadSessionSummary) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * Upload Creative files in the given creative upload session.
     */
    public com.google.api.ads.dfa.axis.v1_17.CreativeUploadSession uploadCreativeFiles(com.google.api.ads.dfa.axis.v1_17.CreativeUploadRequest creativeUploadRequest) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;

    /**
     * <p>Returns the rendering id and rendering version for the given
     * creative ids.</p>
     *           <p>It takes the CreativeRenderingRequest having array of
     * creative ids
     *              and returns the array of CreativeRenderingResult.</p>
     * <p>If any of the creative id is not found then result will not contain
     * that creative id.</p>
     *           <p>Following is a field summary of CreativeRenderingResult:</p>
     * <ul>
     *             <li>
     *               <em>creativeId</em>: the creative id given in the request.
     * </li>
     *             <li>
     *               <em>renderingId</em>: the rendering id for creative.
     * </li>
     *             <li>
     *               <em>renderingVersion</em>: the rendering version for
     * creative.
     *             </li>
     *           </ul>
     *           <p>The methods returns the error message in case of request
     * parameter is invalid.</p>
     *           <p>The rendering id is legacy feature only.</p>
     */
    public com.google.api.ads.dfa.axis.v1_17.CreativeRenderingResult[] getCreativeRenderings(com.google.api.ads.dfa.axis.v1_17.CreativeRenderingRequest creativeRenderingRequest) throws java.rmi.RemoteException, com.google.api.ads.dfa.axis.v1_17.ApiException;
}
